#include <avr/io.h>

#include <stdlib.h>
#include <avr/interrupt.h>

#include "ringbuffer.h"
#include "ringbuffer.c"

unsigned char send_count=0;

unsigned char	inByte;
unsigned char	RxByte;


void uart_init(void) {
	
	UCSRC = 0x06;	// 8bit STOP1bit
	UBRRL = 7;		// clock/baud -1
	UBRRH = 0x00;	
	UCSRB |= (1 << RXCIE) | (1 << RXEN) | (1<<TXCIE) | (1<<TXEN);
}

//################################################### ______________INTERRUPT RX

SIGNAL(SIG_USART0_RX) 
{
	inByte = UDR;
	if (inByte < 0xF0) {	//  process status and databytes, ignore sysex and realtime
		RB_Write(inByte);
	}
}

int uart_putc(unsigned char c) {
		while (!(UCSRA & (1<<UDRE))); // warten bis Senden moeglich    

		UDR = c;
		return 0;
}

void uart_puts(unsigned char *string, unsigned char bytes2Count) {

	send_count = bytes2Count; 
	while (send_count>0) 
	{ 
		uart_putc(*string);
		string++;
		send_count--;
	}
}

int main()
{
	RB_Init();
	
	uart_init();
	sei();

	while(1)
	{
		while (RB_Entries == 0)
		{
			// no unprocessed bytes, wait here
		};	

		RxByte = RB_Read();			// get byte from stack 

		if (RxByte > 0x7F) 
		//if (15 > 3) 
		{
			uart_putc(RxByte);
		} else {
			uart_putc(RxByte);
		}
		
		//uart_putc(RxByte);			// for direct testing only		

	} // end while loop


}// end main

